'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var merge = require('deepmerge'),
    request = require('request-promise');

module.exports = _asyncToGenerator(function* () {
    /**
     * if screenwidth was set, get back to old resolution
     */
    if (this.self.defaultScreenDimension) {
        yield this.instance.windowHandleSize({
            width: this.self.defaultScreenDimension.width,
            height: this.self.defaultScreenDimension.height
        });
    }

    /**
     * end session when using applitools
     */
    if (this.self.options.usesApplitools) {
        // Whether or not we should automatically save this test as baseline.
        var updateBaseline = this.self.isNew && this.applitools.saveNewTests || !this.self.isNew && this.applitools.saveFailedTests;

        var res = yield request({
            qs: { apiKey: this.applitools.apiKey, updateBaseline: updateBaseline },
            url: this.applitools.host + '/api/sessions/running/' + this.self.sessionId,
            method: 'DELETE',
            headers: this.self.headers,
            timeout: this.self.reqTimeout,
            resolveWithFullResponse: true
        });

        if (res.body) {
            this.self.options.resultObject[this.currentArgs.name] = merge({
                id: this.self.sessionId,
                url: this.self.url
            }, JSON.parse(res.body));
            this.self.url = undefined;
            this.self.sessionId = undefined;
            this.self.isNew = undefined;
        }
    }
});
