'use strict';

/**
 * make screenshot via [GET] /session/:sessionId/screenshot
 */

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var modifyElements = function () {
    var _ref = _asyncToGenerator(function* (elements, style, value) {
        if (elements.length === 0) {
            return;
        }

        yield this.instance.selectorExecute(elements, function () {
            var args = Array.prototype.slice.call(arguments).filter(function (n) {
                return !!n;
            }),
                style = args[args.length - 2],
                value = args[args.length - 1];

            args.splice(-2);
            for (var i = 0; i < args.length; ++i) {
                for (var j = 0; j < args[i].length; ++j) {
                    args[i][j].style[style] = value;
                }
            }
        }, style, value);
    });

    return function modifyElements(_x, _x2, _x3) {
        return _ref.apply(this, arguments);
    };
}();

module.exports = _asyncToGenerator(function* () {
    /**
     * take actual screenshot in given screensize just once
     */
    if (this.self.takeScreenshot === false) {
        return;
    }

    this.self.takeScreenshot = false;

    /**
     * gather all elements to hide
     */
    var hiddenElements = [],
        removeElements = [];
    this.queuedShots.forEach(function (args) {
        if (typeof args.hide === 'string') {
            hiddenElements.push(args.hide);
        }
        if (args.hide instanceof Array) {
            hiddenElements = hiddenElements.concat(args.hide);
        }
        if (typeof args.remove === 'string') {
            removeElements.push(args.remove);
        }
        if (args.remove instanceof Array) {
            removeElements = removeElements.concat(args.remove);
        }
    });

    /**
     * hide / remove elements
     */
    yield modifyElements.call(this, hiddenElements, 'visibility', 'hidden');
    yield modifyElements.call(this, removeElements, 'display', 'none');

    /**
     * take 100ms pause to give browser time for rendering
     */
    yield this.instance.pause(100).saveDocumentScreenshot(this.screenshot);

    /**
     * make hidden elements visible again
     */
    yield modifyElements.call(this, hiddenElements, 'visibility', '');
    yield modifyElements.call(this, removeElements, 'display', '');
});
