'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var promisify = require('es6-promisify');
var glob = promisify(require('glob'));
var fs = require('fs');

var rename = promisify(fs.rename);

module.exports = _asyncToGenerator(function* () {
    var files = yield glob('{' + this.regressionPath + ',' + this.baselinePath + '}', {});

    /**
     * if no files were found continue
     */
    if (files.length === 0) {
        return;
    }

    this.isComparable = true;
    this.filename = this.regressionPath;

    /**
     * rename existing files
     */
    if (files.length === 2 && this.updateBaseline && !this.self.options.usesApplitools) {
        yield rename(this.regressionPath, this.baselinePath);
    }
});
