'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _gm = require('gm');

var _gm2 = _interopRequireDefault(_gm);

var _webdriverio = require('webdriverio');

var _getScrollingPosition = require('./scripts/getScrollingPosition');

var _getScrollingPosition2 = _interopRequireDefault(_getScrollingPosition);

var _getScreenDimension = require('./scripts/getScreenDimension');

var _getScreenDimension2 = _interopRequireDefault(_getScreenDimension);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * takes screenshot of the current viewport
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * @param {String} filename  path of file to be saved
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */

exports.default = function () {
    var _ref = _asyncToGenerator(function* (fileName) {
        console.log(require('path').basename(__filename));
        /*!
         * parameter check
         */
        if (typeof fileName !== 'string') {
            throw new _webdriverio.ErrorHandler.CommandError('number or type of arguments don\'t agree with saveScreenshot command');
        }

        /*!
         * get page information like
         * - scroll position
         * - viewport width/height and total width/height
         */
        var scrollPosition = yield this.execute(_getScrollingPosition2.default);
        var screenDimension = yield this.execute(_getScreenDimension2.default);

        /**
         * take screenshot
         */
        var screenshot = yield this.screenshot();

        /**
         * crop image
         */
        return yield new Promise(function (resolve, reject) {
            (0, _gm2.default)(new Buffer(screenshot.value, 'base64')).crop(
            // width
            screenDimension.value.screenWidth,
            // height
            screenDimension.value.screenHeight,
            // top
            scrollPosition.value[0],
            // left
            scrollPosition.value[1]).write(fileName, function (err) {
                if (err) {
                    return reject(err);
                }

                return resolve();
            });
        });
    });

    function viewportScreenshot(_x) {
        return _ref.apply(this, arguments);
    }

    return viewportScreenshot;
}();
