'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _workflow = require('./workflow.js');

var _workflow2 = _interopRequireDefault(_workflow);

var _viewportScreenshot = require('./viewportScreenshot.js');

var _viewportScreenshot2 = _interopRequireDefault(_viewportScreenshot);

var _documentScreenshot = require('./documentScreenshot.js');

var _documentScreenshot2 = _interopRequireDefault(_documentScreenshot);

var _syncImages = require('./syncImages');

var _syncImages2 = _interopRequireDefault(_syncImages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var DEFAULT_PROPERTIES = {
    screenshotRoot: 'webdrivercss',
    failedComparisonsRoot: 'webdrivercss/diff',
    misMatchTolerance: 0.05,
    screenWidth: [],
    warning: [],
    resultObject: {},
    updateBaseline: false,
    applitools: {}
};

/**
 * WebdriverCSS
 * initialise plugin
 */

var WebdriverCSS = function () {
    function WebdriverCSS(webdriverInstance, options) {
        _classCallCheck(this, WebdriverCSS);

        if (!webdriverInstance) {
            throw new Error('A WebdriverIO instance is needed to initialise WebdriverCSS');
        }

        this.instance = webdriverInstance;
        this.options = (0, _deepmerge2.default)(DEFAULT_PROPERTIES, options || {});

        /**
        * create directory if it doesn't already exist
        */
        this.createDirectory(this.options.screenshotRoot);
        this.createDirectory(this.options.failedComparisonsRoot);

        /**
         * add WebdriverCSS command to WebdriverIO instance
         */
        this.instance.addCommand('saveViewportScreenshot', _viewportScreenshot2.default.bind(this));
        this.instance.addCommand('saveDocumentScreenshot', _documentScreenshot2.default.bind(this));
        this.instance.addCommand('webdrivercss', _workflow2.default.bind(this));
        this.instance.addCommand('sync', _syncImages2.default.bind(this));
    }

    _createClass(WebdriverCSS, [{
        key: 'createDirectory',
        value: function createDirectory(path) {
            if (_fsExtra2.default.existsSync(path)) {
                return;
            }

            _fsExtra2.default.mkdirsSync(path, '0755', true);
        }
    }]);

    return WebdriverCSS;
}();

/**
 * expose WebdriverCSS
 */


module.exports.init = function (webdriverInstance, options) {
    return new WebdriverCSS(webdriverInstance, options);
};
